    REM ***************
    REM *** TRACKER ***
    REM ***************
    REM
    REM This programs displays the locations of various features
    REM on Jupiter for Summer 1994.  This code contains pieces from
    REM lots of other code and it is not well organized yet.
    REM
    DEFDBL A-Z
    PII = 3.141593327#
    P = PII / 180
    P1 = 0: P2 = 1: 'Video Pages
    DIM NM$(50), DA(50), HO(50), MN(50), LAT(50), LONF(50), MERA(50), LON(50)
    ZONE = 0
    REM ******************** PROGRAM CONTROL *******************************
    GOSUB 400: '  Print Program Info and get Time Zone
    GOSUB 500: '  Read Feature and Impact Data
    GOSUB 200: '  Find System II Longitudes of Impact Sites
101 CHG = 0
    GOSUB 1200: ' Get Date and Time
    GOSUB 1220: ' Universal Date and Time & Correct Time
    GOSUB 100: '  Find Longitude of Central Meridian (MER)
    GOSUB 300: '  Draw Jupiter with Features and Impact Sites
111 GOSUB 1200: ' Get Date and Time
    GOSUB 1220: ' Universal Date and Time
110 SCREEN 9, , P1, P1
    GOSUB 350: '  Print Info (Date,time, etc.)
    Z$ = INKEY$
    IF Z$ = "x" OR Z$ = "X" THEN GOTO 9999
    IF Z$ = "?" THEN GOSUB 1000: GOSUB 300
    IF Z$ = "C" OR Z$ = "c" THEN GOTO 101
    IF Z$ = "D" OR Z$ = "d" THEN NSEC = 0: GOSUB 2000
    IF Z$ = "I" OR Z$ = "i" THEN GOSUB 2600
    IF Z$ = "M" THEN NMIN = NMIN + 1: CHG = 1: NSEC = 0
    IF Z$ = "m" THEN NMIN = NMIN - 1: CHG = 1: NSEC = 0
    IF Z$ = "T" THEN NMIN = NMIN + 10: CHG = 1: NSEC = 0
    IF Z$ = "t" THEN NMIN = NMIN - 10: CHG = 1: NSEC = 0
    IF Z$ = "H" THEN LHOUR = LHOUR + 1: CHG = 1: NSEC = 0
    IF Z$ = "h" THEN LHOUR = LHOUR - 1: CHG = 1: NSEC = 0
    IF LHOUR <> LASTH OR NMIN <> LASTM THEN GOSUB 2500
    LASTH = LHOUR: LASTM = NMIN
    IF CHG = 0 THEN GOTO 111 ELSE GOTO 110

2000 REM **************** Change Date and Time Manually *********************
     CHG = 1
     LOCATE 2, 44
     PRINT "                                   "
     LOCATE 3, 44
     PRINT "                                   "
     LOCATE 4, 44
     PRINT "                                   "
     LOCATE 5, 44
     PRINT "                                   "
     LOCATE 2, 44
     PRINT "Enter Local Date"
     LOCATE 3, 44
     INPUT "      Month (MM) : ", LMONTH
     LOCATE 4, 44
     INPUT "        Day (DD) : ", LDAY
     LOCATE 5, 44
     INPUT "     Year (YYYY) : ", LYEAR
     LOCATE 2, 44
     PRINT "                                   "
     LOCATE 3, 44
     PRINT "                                   "
     LOCATE 4, 44
     PRINT "                                   "
     LOCATE 5, 44
     PRINT "                                   "
     LOCATE 2, 44
     PRINT "Enter Local Time"
     LOCATE 3, 44
     INPUT "          Hour : ", LHOUR
     LOCATE 4, 44
     INPUT "        Minute : ", NMIN
     GOSUB 2500
     RETURN

2500 REM ************ Update Screen after Changing Date or Time ***********
     GOSUB 1220: GOSUB 100: GOSUB 300
     RETURN

2600 REM *************** Change date and time to first impact *************
     CHG = 1
     LYEAR = 1994
     LMONTH = 7
     LDAY = DA(1)
     LHOUR = HO(1) - DHOUR
     NMIN = MN(1)
     NSEC = 0
     GOSUB 2500
     RETURN

300 REM ********************* DRAW JUPITER ***************************
    SWAP P1, P2
    SCREEN 9, , P1, P2
    CLS
    GOSUB 350
    PALETTE 4, 20: 'Red Clouds
    LOCATE 25, 1: PRINT "0"; CHR$(248);
    LOCATE 17, 1: PRINT "-30"; CHR$(248);
    LOCATE 11, 1: PRINT "-60"; CHR$(248);
    LINE (55, 233)-(35, 233), 15: ' -30 degree line
    LINE (165, 153)-(35, 153), 15: ' -60 degree line
    CIRCLE (320, 342), 300, 4, 0, PII: 'Draw Jupiter`s Surface
    LINE (20, 342)-(620, 342), 4
    PAINT (320, 335), 7, 4
    LINE (23, 311)-(617, 311), 4:  'SEB  -8 Degrees
    LINE (36, 269)-(604, 269), 4: ' SEB  -20
    PAINT (320, 275), 4, 4: '       SEB
    LINE (52, 241)-(586, 241), 4: ' STB  27
    LINE (65, 225)-(575, 225), 4: ' STB  32
    PAINT (320, 227), 4, 4: '       STB
    LINE (90, 201)-(550, 201), 4: ' SSTB  40
    LINE (97, 196)-(543, 196), 4: ' SSTB  42
    PAINT (320, 199), 4, 4: '       SSTB
    REM *********************** Draw Red Spot **************************
    DIFF = LONF(1) - MER
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 70 THEN GOTO 10
    XPOS = 320 + (282 * SIN(DIFF * P))
    CIRCLE (XPOS, 268), 50 * COS(DIFF * P), 4, , , .45 / COS(DIFF * P): 'RED
    PAINT (XPOS, 268), 4, 4: 'RED
    CIRCLE (XPOS, 268), 50 * COS(DIFF * P), 7, , , .45 / COS(DIFF * P): 'RED
10  REM *********************** Draw White Spots **************************
    FOR J = 2 TO 4
    DIFF = LONF(J) - MER
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 60 THEN GOTO 20
    XPOS = 320 + (282 * SIN(DIFF * P))
    CIRCLE (XPOS, 233), 12, 7, , , .6: 'WHITE
    PAINT (XPOS, 233), 7, 7: 'WHITE
20  NEXT J
    REM ******************* DRAW IMPACT SITES *****************************
    IF NYEAR <> 1994 OR NMONTH <> 7 THEN GOTO 31
    FOR J = 1 TO NNN
    IF NDAY < DA(J) THEN GOTO 30
    IF NDAY = DA(J) AND NHOUR < HO(J) THEN GOTO 30
    IF NDAY = DA(J) AND NHOUR = HO(J) AND NMIN < MN(J) THEN GOTO 30
    DIFF = LON(J) - MER
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 90 THEN GOTO 30
    XPOS = 320 + (215 * SIN(DIFF * P))
    CIRCLE (XPOS, 342 + 219 * SIN(LAT(J) * P)), 3, 9
    PAINT (XPOS, 342 + 219 * SIN(LAT(J) * P)), 9, 9
30  NEXT J
31  REM ***************** TYPE COMMANDS, ETC. *****************************
    LINE (0, 7)-(210, 75), 15, B
    LOCATE 7, 20
    PRINT "System II Longitude of the Central Meridian "
    LOCATE 11, 67
    PRINT "Impact Sites"
    LOCATE 12, 67
    PRINT "Appear Here"
    LINE (580, 170)-(543, 187), 15
    LINE (215, 7)-(330, 75), 15, B
    LOCATE 2, 30
    PRINT "? - help"
    LOCATE 3, 30
    PRINT "x - exit"
    LOCATE 4, 30
    PRINT "d - date"
    LOCATE 5, 30
    PRINT "c - current"
    LINE (335, 7)-(630, 75), 15, B
    LOCATE 2, 44
    PRINT "M/m - forward/reverse by 1 minute"
    LOCATE 3, 44
    PRINT "T/t - forward/reverse by 10 minutes"
    LOCATE 4, 44
    PRINT "H/h - forward/reverse by 1 hour"
    LOCATE 5, 44
    PRINT "  i - first impact "
    LOCATE 16, 80: PRINT "F"
    LOCATE 17, 80: PRINT "O"
    LOCATE 18, 80: PRINT "L"
    LOCATE 19, 80: PRINT "L"
    LOCATE 20, 80: PRINT "O"
    LOCATE 21, 80: PRINT "W"
    LOCATE 22, 80: PRINT "I"
    LOCATE 23, 80: PRINT "N"
    LOCATE 24, 80: PRINT "G";
    SCREEN 9, , P2, P1
    RETURN

350 REM ****************  PRINT TIME AND LONGITUDE *************************
    IF CHG = 1 THEN GOTO 356
    TT$ = TIME$
355 IF TT$ = TIME$ GOTO 355
356 LOCATE 2, 2
    PRINT USING "Local Date : ##/##/####"; LMONTH; LDAY; LYEAR
    LOCATE 3, 2
    PRINT USING "Local Time : ##:##:##"; LHOUR; NMIN; NSEC
    LOCATE 4, 2
    PRINT USING "Univ. Date : ##/##/####"; NMONTH; NDAY; NYEAR
    LOCATE 5, 2
    PRINT USING "Univ. Time : ##:##:##"; NHOUR; NMIN; NSEC
    LOCATE 8, 38: PRINT USING "###.##!"; MER; CHR$(248)
    RETURN
    
400  REM ********************** Print Info *******************************
     SCREEN 9
     LOCATE 2, 23
     PRINT "   F E A T U R E   L O C A T O R"
     PRINT TAB(30); "f o r   J u p i t e r": PRINT : PRINT
     PRINT "            This program will use the time and date from your computer's"
     PRINT
     PRINT "       clock to determine and display the approximate locations of a few"
     PRINT
     PRINT "       features on the southern hemisphere of Jupiter as seen from Earth."
     PRINT
     PRINT "       Impact sites of the fragments of comet Shoemaker-Levy 9 appear after"
     PRINT
     PRINT "       the predicted impact times and are shown in blue.  In this program"
     PRINT
     PRINT "       the impacts sites remain on Jupiter until the end of July 1994.  This"
     PRINT
     PRINT "       program will be updated periodically during the summer of 1994."
     PRINT
     PRINT "                           Last Updated : May 26, 1994 "
     PRINT
     PRINT
     PRINT "                  Enter the number of hours to add to local"
     INPUT "                time to get Universal Time (Default -> 5) : ", DHOUR$
     IF DHOUR$ = "" THEN DHOUR = 5: GOTO 1610
     LN = LEN(DHOUR$): DHOUR = 0
     FOR I = 1 TO LN
     DHOR$ = LEFT$(RIGHT$(DHOUR$, I), 1)
     DHOR = ASC(DHOR$) - 48
     IF DHOR = -3 THEN DHOUR = -1 * DHOUR: GOTO 1600
     DHOUR = DHOUR + (DHOR * (10 ^ (I - 1)))
1600 NEXT I
1610 SCREEN 9, , 1, 1: CLS
     SCREEN 9, , 0, 0: CLS
     RETURN
    
200 REM ******************* FIND LONGITUDE OF IMPACTS **********************
    PRINT "Working..."
    FOR J = 1 TO NNN
    MONTH = 7
    day = DA(J)
    YEAR = 1994
    HOUR = HO(J)
    MIN = MN(J)
    GOSUB 100
    LON(J) = (MER + 180 - MERA(J))
    IF LON(J) > 360 THEN LON(J) = LON(J) - 360
    NEXT J
    RETURN

100 REM ********** FIND SYSTEM II LONGITUDE OF CENTRAL MERIDIAN ***********
    REM From July 1993 Issue of Astronomy page 65
    REM MONTH,DAY0,YEAR,MIN -> MER
    DAY0 = day + (HOUR + ZONE) / 24 + (MIN / (60 * 24)) + 1 / 1440
    IF MONTH < 3 THEN YEAR = YEAR - 1: MONTH = MONTH + 12
    a = INT(YEAR / 100): B = 2 - a + INT(a / 4)
    JD = INT(365.25 * YEAR) + INT(30.6001 * (MONTH + 1)) + DAY0 + 1720994.5# + B
    DAYS = JD - 2451545!: CEN = DAYS / 36525!
    RTD = 57.29578
    REM  Calculate orbit of Jupiter
    PP = 11.8567785#: PI = 1.3053 - 4.15 / 3600 * CEN
    PE = 4.839266E-02 - .0001288 * CEN: PA = 5.20336301# + 6.0737E-04 * CEN
    PO = 100.55615# + 1217.17 / 3600 * CEN: PW = 14.75385 + 839.93 / 3600 * CEN
    PL = 34.40438 + 8.308676199999999D-02 * DAYS
    MEAN = PL - PW: Z = MEAN / 360: MEAN = MEAN - 360 * INT(Z)
    TRUE = MEAN + 360 / 3.14159265359# * PE * SIN(MEAN / RTD)
    Z = TRUE / 360: TRUE = TRUE - 360 * INT(Z)
    L = TRUE + PW: R = PA * (1 - PE * PE) / (1 + PE * COS(TRUE / RTD))
    SINPSI = SIN((L - PO) / RTD) * SIN(PI / RTD)
    PSI = ATN(SINPSI / SQR(1 - SINPSI * SINPSI))
    NUM = SIN((L - PO) / RTD) * COS(PI / RTD): DEN = COS((L - PO) / RTD)
    LP = ATN(NUM / DEN) * RTD + PO: IF DEN < 0 THEN LP = LP + 180
    RP = R * COS(PSI)
    REM  Calculate Earth's orbit
    EE = 1.671022E-02 - 3.804E-05 * CEN: EA = 1.00000011# - 5E-08 * CEN
    EW = 102.94719# + 1198.28 / 3600 * CEN: EL = 100.46435# + .9856091 * DAYS
    OBL = 23.43928
    MEANE = EL - EW: Z = MEANE / 360: MEANE = MEANE - 360 * INT(Z)
    TRUEE = MEANE + 360 / 3.14159265359# * EE * SIN(MEANE / RTD)
    Z = TRUEE / 360: TRUEE = TRUEE - 360 * INT(Z)
    LE = TRUEE + EW: RE = EA * (1 - EE * EE) / (1 + EE * COS(TRUEE / RTD))
    LAMB = ATN(RE * SIN((LP - LE) / RTD) / (RP - RE * COS((LP - LE) / RTD))) * RTD + LP
    BETA = ATN(RP * TAN(PSI) * SIN((LAMB - LP) / RTD) / (RE * SIN((LP - LE) / RTD))) * RTD
    REM  Determine Jupiter's position
    NUM = SIN(LAMB / RTD) * COS(OBL / RTD) - TAN(BETA / RTD) * SIN(OBL / RTD)
    DEN = COS(LAMB / RTD)
    RA = ATN(NUM / DEN) * RTD: IF NUM * DEN < 0 THEN RA = RA + 180
    IF NUM < 0 THEN RA = RA + 180
    SINDEC = SIN(BETA / RTD) * COS(OBL / RTD) + COS(BETA / RTD) * SIN(OBL / RTD) * SIN(LAMB / RTD)
    DEC = ATN(SINDEC / SQR(1 - SINDEC * SINDEC)) * RTD
    DSQRD = RE * RE + R * R - 2 * RE * R * COS((L - LE) / RTD): DIST = SQR(DSQRD)
    REM  Compute central meridian on Jupiter at midnight
    A0 = 268.05 - 8.999999E-03 * CEN: D0 = 64.49 + .003 * CEN
    W0 = 43.3 + 870.27 * DAYS: Z = W0 / 360: W0 = W0 - 360 * INT(Z)
    W1 = W0 - 870.27 * .0057755 * DIST
    SINB = -SIN(D0 / RTD) * SIN(DEC / RTD) - COS(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD)
    COSB = SQR(1 - SINB * SINB)
    SINK = (SIN(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD) - COS(D0 / RTD) * SIN(DEC / RTD)) / COSB
    COSK = COS(DEC / RTD) * SIN((A0 - RA) / RTD) / COSB
    K = ATN(SINK / COSK) * RTD
    MER = W1 - K: IF COSK < 0 THEN MER = MER + 180
    IF MER > 360 THEN MER = MER - 360
    IF MER < 0 THEN MER = MER + 360
    RETURN

500 REM ********************* READ DATA *********************************
    OPEN "TRACKER1.DAT" FOR INPUT AS #1
    INPUT #1, Z$, Z$, Z$
    FOR I = 1 TO 4
    INPUT #1, Z$, LONF(I)
    NEXT I
    INPUT #1, Z$, Z$, NNN, Z$, Z$, Z$, Z$, Z$, Z$
    FOR I = 1 TO NNN
    INPUT #1, NM$(I), DA(I), HO(I), MN(I), LAT(I), MERA(I)
    NEXT I
    CLOSE
    RETURN

1000 REM ****************** Print Help ***********************************
     SCREEN 9, , P1, P1
     CLS
     PRINT "C O M M A N D S"
     PRINT
     PRINT "     ? - show this help screen"
     PRINT "     x - exit program"
     PRINT "     d - change the date and time of observation"
     PRINT "     c - display current view of Jupiter"
     PRINT "           (i.e. use computer's clock)"
     PRINT
     PRINT "     M - increment time by 1 minute "
     PRINT "     m - decrement time by 1 minute "
     PRINT
     PRINT "     T - increment time by 10 minutes "
     PRINT "     t - decrement time by 10 minutes "
     PRINT
     PRINT "     H - increment time by 1 hour "
     PRINT "     h - decrement time by 1 hour "
     PRINT
     PRINT "     i - changes date and time to that of the first impact"
     PRINT
     INPUT "Press enter.", ASDF$
     CLS
     PRINT "                             FEATURE INFORMATION "
     PRINT
     PRINT "      The southern hemisphere of Jupiter displayed at the bottom of the screen"
     PRINT "shows the following belts from bottom to top: south equatorial, south temperate,"
     PRINT "and south south temperate belt.  The 'following' limb of Jupiter is labled on"
     PRINT "the right of the screen.  The Great Red Spot is displayed at a latitude of -20"
     PRINT "degrees when it is visible and the white spots FA, BC, and DE are displayed at"
     PRINT "a latitude of -30 degrees when visible.  The system II longitudes of these"
     PRINT "features are variable, so the data file TRACKER1.DAT needs to be updated"
     PRINT "periodically. "
     PRINT "     The times and locations of impact of the fragments of comet Shoemaker-Levy"
     PRINT "9 are also contained in TRACKER1.DAT.  The system II longitudes of the impact"
     PRINT "sites are determined in this program from the impact times and the midnight"
     PRINT "meridian angle.  Here are the coodinates of the features displayed in this"
     PRINT "program:"
     PRINT "                                                      System II"
     PRINT "                Feature             Latitude          Longitude"
     PRINT
     PRINT USING "             Great Red Spot            -20!              ###!"; CHR$(248); LONF(1); CHR$(248)
     PRINT USING "             White Spot FA             -30!              ###!"; CHR$(248); LONF(2); CHR$(248)
     PRINT USING "             White Spot BC             -30!              ###!"; CHR$(248); LONF(3); CHR$(248)
     PRINT USING "             White Spot DE             -30!              ###!"; CHR$(248); LONF(4); CHR$(248)
     PRINT
     INPUT "Press enter.", ASDF$
     CLS
     PRINT "              Impact      Impact    Jovicentric    Meridian     System II  "
     PRINT " Fragment      Date        Time       Latitude      Angle       Longitude  "
     FOR J = 1 TO NNN
     PRINT USING "    \  \   July ## 1994  ##:## UT      ###.#!      ###.#!          ###! "; NM$(J); DA(J); HO(J); MN(J); LAT(J); CHR$(248); MERA(J); CHR$(248); LON(J); CHR$(248)
     NEXT J
     PRINT
     INPUT "                                                             Press enter.", ASDF$
     CLS
     RETURN
   
1200 REM ********************************************************************
     REM *                                                                  *
     REM *    Determine Time                                                *
     REM *                                                                  *
     REM ********************************************************************
     T$ = LEFT$(DATE$, 1): LMONTH = (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(DATE$, 2), 1): LMONTH = LMONTH + ASC(T$) - 48
     T$ = RIGHT$(LEFT$(DATE$, 4), 1): LDAY = (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(DATE$, 5), 1): LDAY = LDAY + ASC(T$) - 48
     T$ = RIGHT$(LEFT$(DATE$, 7), 1): LYEAR = (ASC(T$) - 48) * 1000
     T$ = RIGHT$(LEFT$(DATE$, 8), 1): LYEAR = LYEAR + (ASC(T$) - 48) * 100
     T$ = RIGHT$(LEFT$(DATE$, 9), 1): LYEAR = LYEAR + (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(DATE$, 10), 1): LYEAR = LYEAR + ASC(T$) - 48
     T$ = (LEFT$(TIME$, 1)): LHOUR = (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(TIME$, 2), 1): LHOUR = LHOUR + ASC(T$) - 48
     T$ = RIGHT$(LEFT$(TIME$, 4), 1): NMIN = (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(TIME$, 5), 1): NMIN = NMIN + ASC(T$) - 48
     T$ = RIGHT$(LEFT$(TIME$, 7), 1): NSEC = (ASC(T$) - 48) * 10
     T$ = RIGHT$(LEFT$(TIME$, 8), 1): NSEC = NSEC + ASC(T$) - 48
     RETURN

1220 REM ********************************************************************
     REM *                                                                  *
     REM *  Correct Time after Time Increment                               *
     REM *                                                                  *
     REM ********************************************************************
     IF NSEC >= 60 THEN NSEC = NSEC - 60: NMIN = NMIN + 1
     IF NSEC < 0 THEN NSEC = NSEC + 60: NMIN = NMIN - 1
     IF NMIN >= 60 THEN NMIN = NMIN - 60: LHOUR = LHOUR + 1
     IF NMIN < 0 THEN NMIN = NMIN + 60: LHOUR = LHOUR - 1
     LastDAY = 31
     IF (LMONTH = 4) OR (LMONTH = 6) THEN LastDAY = 30
     IF (LMONTH = 9) OR (LMONTH = 11) THEN LastDAY = 30
     IF LMONTH = 2 THEN LastDAY = 28
     IF (INT(LYEAR / 4) = (LYEAR / 4)) AND (LMONTH = 2) THEN LastDAY = 29
     IF LHOUR >= 24 THEN LHOUR = LHOUR - 24: LDAY = LDAY + 1
     IF LHOUR < 0 THEN LHOUR = LHOUR + 24: LDAY = LDAY - 1
     IF LDAY > LastDAY THEN LDAY = LDAY - LastDAY: LMONTH = LMONTH + 1
     LastDAY = 31
     IF ((LMONTH - 1) = 4) OR ((LMONTH - 1) = 6) THEN LastDAY = 30
     IF ((LMONTH - 1) = 9) OR ((LMONTH - 1) = 11) THEN LastDAY = 30
     IF (LMONTH - 1) = 2 THEN LastDAY = 28
     IF (INT(LYEAR / 4) = (LYEAR / 4)) AND ((LMONTH - 1) = 2) THEN LastDAY = 29
     IF LDAY < 1 THEN LDAY = LDAY + LastDAY: LMONTH = LMONTH - 1
     IF LMONTH > 12 THEN LMONTH = LMONTH - 12: LYEAR = LYEAR + 1
     IF LMONTH < 1 THEN LMONTH = LMONTH + 12: LYEAR = LYEAR - 1
     NMONTH = LMONTH
     NYEAR = LYEAR
     NDAY = LDAY
     NHOUR = LHOUR + DHOUR
     LastDAY = 31
     IF (NMONTH = 4) OR (NMONTH = 6) THEN LastDAY = 30
     IF (NMONTH = 9) OR (NMONTH = 11) THEN LastDAY = 30
     IF NMONTH = 2 THEN LastDAY = 28
     IF (INT(NYEAR / 4) = (NYEAR / 4)) AND (NMONTH = 2) THEN LastDAY = 29
     IF NHOUR >= 24 THEN NHOUR = NHOUR - 24: NDAY = NDAY + 1
     IF NHOUR < 0 THEN NHOUR = NHOUR + 24: NDAY = NDAY - 1
     IF NDAY > LastDAY THEN NDAY = NDAY - LastDAY: NMONTH = NMONTH + 1
     LastDAY = 31
     IF ((NMONTH - 1) = 4) OR ((NMONTH - 1) = 6) THEN LastDAY = 30
     IF ((NMONTH - 1) = 9) OR ((NMONTH - 1) = 11) THEN LastDAY = 30
     IF (NMONTH - 1) = 2 THEN LastDAY = 28
     IF (INT(NYEAR / 4) = (NYEAR / 4)) AND ((NMONTH - 1) = 2) THEN LastDAY = 29
     IF NDAY < 1 THEN NDAY = NDAY + LastDAY: NMONTH = NMONTH - 1
     IF NMONTH > 12 THEN NMONTH = NMONTH - 12: NYEAR = NYEAR + 1
     IF NMONTH < 1 THEN NMONTH = NMONTH + 12: NYEAR = NYEAR - 1
     YEAR = NYEAR
     MONTH = NMONTH
     day = NDAY
     HOUR = NHOUR
     MIN = NMIN
     RETURN

9999 REM ********************************************************************
     REM *                                                                  *
     REM *  Print End of Program Information                                *
     REM *                                                                  *
     REM ********************************************************************
     SCREEN 0
     CLS : LOCATE 11, 1
     PRINT TAB(17); "            TRACKER is a free program."
     PRINT
     PRINT TAB(17); "        Dan Bruton, Texas A & M University"
     PRINT
     PRINT TAB(17); "              email : astro@tamu.edu"
     PRINT : PRINT : PRINT : PRINT : PRINT : PRINT : PRINT : PRINT
     END
 
    REM *********************** END OF PROGRAM ***************************

